%define anolis_release 2
%global fontname bitmap
%global fontconf 66-%{fontname}
%global common_desc \
The bitmap-fonts package provides a number of bitmap fonts selected\
from the xorg package designed for use locations such as\
terminals.

Name: bitmap-fonts
Version: 0.3
Epoch: 1
Release: %{anolis_release}%{?dist}
License: GPLv2 and MIT and Lucida
Source0: bitmap-fonts-%{version}.tar.bz2
Source1: fixfont-3.5.tar.bz2
Source2: LICENSE
Source3: 66-bitmap-console.conf
Source4: 66-bitmap-fangsongti.conf
Source5: 66-bitmap-fixed.conf
Source6: 66-bitmap-lucida-typewriter.conf
BuildArch: noarch
Summary: Selected set of bitmap fonts
BuildRequires: bdftopcf fonttosfnt
BuildRequires: fontpackages-devel
BuildRequires: python3
BuildRequires: /usr/bin/ftdump
BuildRequires: make


%description
%common_desc

%package -n %{fontname}-fonts-compat
Summary: Compatibility files of bitmap-font families
Provides: bitmap-fonts = %{epoch}:%{version}-%{release}
Requires: %{fontname}-lucida-typewriter-fonts = %{epoch}:%{version}-%{release}
Requires: %{fontname}-fangsongti-fonts = %{epoch}:%{version}-%{release}
Requires: %{fontname}-console-fonts = %{epoch}:%{version}-%{release}
Requires: %{fontname}-fixed-fonts = %{epoch}:%{version}-%{release}
Requires: ucs-miscfixed-fonts
Obsoletes: bitmap-fonts < %{epoch}:%{version}-%{release}
Conflicts: %{fontname}-opentype-fonts-compat

%description -n %{fontname}-fonts-compat
%common_desc
Meta-package for installing all font families of bitmap.

%files -n %{fontname}-fonts-compat

%package -n %{fontname}-opentype-fonts-compat
Summary:  Compatibility files of bitmap-font families (opentype version)
Requires: %{fontname}-lucida-typewriter-opentype-fonts = %{epoch}:%{version}-%{release}
Requires: %{fontname}-fangsongti-opentype-fonts = %{epoch}:%{version}-%{release}
Requires: %{fontname}-console-opentype-fonts = %{epoch}:%{version}-%{release}
Requires: %{fontname}-fixed-opentype-fonts = %{epoch}:%{version}-%{release}
Requires: ucs-miscfixed-opentype-fonts
Conflicts: %{fontname}-fonts-compat

%description -n %{fontname}-opentype-fonts-compat
%common_desc
Meta-package for installing all font families of opentype bitmap.

%files -n %{fontname}-opentype-fonts-compat

%package -n bitmap-lucida-typewriter-fonts
Summary: Selected CJK bitmap fonts for Anaconda
Requires: fontpackages-filesystem
Provides: %{name}-cjk = %{epoch}:%{version}-%{release}
License: Lucida
Conflicts: bitmap-lucida-typewriter-opentype-fonts

%description -n bitmap-lucida-typewriter-fonts
%common_desc

%_font_pkg -n lucida-typewriter -f %{fontconf}-lucida-typewriter.conf lut*.pcf.gz
%doc LU_LEGALNOTICE

%package -n bitmap-lucida-typewriter-opentype-fonts
Summary: Selected CJK bitmap fonts for Anaconda (opentype version)
Requires: fontpackages-filesystem
License: Lucida
Conflicts: bitmap-lucida-typewriter-fonts

%description -n bitmap-lucida-typewriter-opentype-fonts
%common_desc

%_font_pkg -n lucida-typewriter-opentype -f %{fontconf}-lucida-typewriter.conf lut*.otb
%doc LU_LEGALNOTICE

%package -n bitmap-fangsongti-fonts
Summary: Selected CJK bitmap fonts for Anaconda
Requires: fontpackages-filesystem
Provides: %{name}-cjk = %{epoch}:%{version}-%{release}
License: MIT
Conflicts: bitmap-fangsongti-opentype-fonts

%description -n %{fontname}-fangsongti-fonts
bitmap-fonts-cjk package contains bitmap fonts used by Anaconda. They are
selected from the xorg packages, and the font encoding are converted from 
native encoding to ISO10646. They are only intended to be used in Anaconda.

%_font_pkg -n fangsongti -f %{fontconf}-fangsongti.conf fangsongti*.pcf.gz
%doc LICENSE

%package -n bitmap-fangsongti-opentype-fonts
Summary: Selected CJK bitmap fonts for Anaconda (opentype version)
Requires: fontpackages-filesystem
License: MIT
Conflicts: bitmap-fangsongti-fonts

%description -n %{fontname}-fangsongti-opentype-fonts
%common_desc

%_font_pkg -n fangsongti-opentype -f %{fontconf}-fangsongti.conf fangsongti*.otb
%doc LICENSE

%package -n bitmap-console-fonts
Summary: Selected set of bitmap fonts
Requires: fontpackages-filesystem
License: GPLv2
Conflicts: bitmap-console-opentype-fonts

%description -n %{fontname}-console-fonts
%common_desc

%_font_pkg -n console -f %{fontconf}-console.conf console8x16*.pcf.gz

%package -n bitmap-console-opentype-fonts
Summary: Selected set of bitmap fonts (opentype version)
Requires: fontpackages-filesystem
License: GPLv2
Conflicts: bitmap-console-fonts

%description -n %{fontname}-console-opentype-fonts
%common_desc

%_font_pkg -n console-opentype -f %{fontconf}-console.conf console8x16*.otb

%package -n bitmap-fixed-fonts
Summary: Selected set of bitmap fonts
Requires: fontpackages-filesystem
License: GPLv2
Conflicts: bitmap-fixed-opentype-fonts

%description -n %{fontname}-fixed-fonts
%common_desc

%_font_pkg -n fixed -f %{fontconf}-fixed.conf  console9*.pcf.gz

%package -n bitmap-fixed-opentype-fonts
Summary: Selected set of bitmap fonts (opentype version)
Requires: fontpackages-filesystem
License: GPLv2
Conflicts: bitmap-fixed-fonts

%description -n %{fontname}-fixed-opentype-fonts
%common_desc

%_font_pkg -n fixed-opentype -f %{fontconf}-fixed.conf console9*.otb


%prep
%setup -q -a 1
cp %{SOURCE2} .


%build
%{nil}

%install
rm -rf $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT

pushd fixfont-3.5
make install DESTDIR=$RPM_BUILD_ROOT
popd

mv $RPM_BUILD_ROOT/usr/share/fonts/bitmap-fonts %{buildroot}%{_fontdir}

rm %{buildroot}%{_fontdir}/[0-9]*.pcf
rm %{buildroot}%{_fontdir}/console8x8.pcf
rm README

# Convert to OpenType Bitmap Font
rm [0-9]*.bdf fixfont-3.5/[0-9]*.bdf

for bdf in `ls *.bdf`;
do fonttosfnt -b -c -g 2 -m 2 -o ${bdf%%bdf}otb  $bdf;
done
install -m 0644 -p *.otb %{buildroot}%{_fontdir}

pushd fixfont-3.5
for bdf in `ls *.bdf`;
do fonttosfnt -b -c -g 2 -m 2 -o ${bdf%%bdf}otb  $bdf;
done
# For console9x15.otb
fonttosfnt -b -c -g 2 -m 2 -o console9x15.otb console9x15.pcf

install -m 0644 -p *.otb %{buildroot}%{_fontdir}
popd

gzip %{buildroot}%{_fontdir}/*.pcf

install -m 0755 -d %{buildroot}%{_fontconfig_templatedir} \
                   %{buildroot}%{_fontconfig_confdir}

# Repeat for every font family
install -m 0644 -p %{SOURCE3} \
        %{buildroot}%{_fontconfig_templatedir}/%{fontconf}-console.conf

install -m 0644 -p %{SOURCE4} \
        %{buildroot}%{_fontconfig_templatedir}/%{fontconf}-fangsongti.conf

install -m 0644 -p %{SOURCE5} \
        %{buildroot}%{_fontconfig_templatedir}/%{fontconf}-fixed.conf

install -m 0644 -p %{SOURCE6} \
        %{buildroot}%{_fontconfig_templatedir}/%{fontconf}-lucida-typewriter.conf


for fconf in %{fontconf}-console.conf \
             %{fontconf}-fangsongti.conf \
             %{fontconf}-fixed.conf \
             %{fontconf}-lucida-typewriter.conf ; do
  ln -s %{_fontconfig_templatedir}/$fconf \
        %{buildroot}%{_fontconfig_confdir}/$fconf
done


%changelog
* Tue Jul 26 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1:0.3-2
- fix version dependency

* Tue Apr 19 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1:0.3-1
- init from upstream
- add epoch version to make sure update
